Index: detail/io.hpp
===================================================================
--- detail/io.hpp	(revision 317)
+++ detail/io.hpp	(working copy)
@@ -103,4 +103,5 @@
  * 
  */
 
-#endif // BOOST_GIL_EXTENSION_IO_IO_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_IO_HPP_INCLUDED
+
Index: detail/jpeg_io_read.hpp
===================================================================
--- detail/jpeg_io_read.hpp	(revision 317)
+++ detail/jpeg_io_read.hpp	(working copy)
@@ -194,28 +194,29 @@
     template<typename View>
     void apply_impl( const View& view )
     {
-        start_decompress();
+		
+        this->start_decompress();
 
-        switch( _info._color_space )
+        switch(this->_info._color_space )
         {
         case JCS_GRAYSCALE:
-            io_error_if(_info._num_components!=1,"reader<jpeg>: error in image data");
+            io_error_if(this->_info._num_components!=1,"reader<jpeg>: error in image data");
             read_rows<gray8_pixel_t>( view );
             break;
         case JCS_RGB:
-            io_error_if(_info._num_components!=3,"reader<jpeg>: error in image data");
+            io_error_if(this->_info._num_components!=3,"reader<jpeg>: error in image data");
             read_rows<rgb8_pixel_t>( view );
         case JCS_YCbCr:
-            io_error_if(_info._num_components!=3,"reader<jpeg>: error in image data");
+            io_error_if(this->_info._num_components!=3,"reader<jpeg>: error in image data");
             //!\todo add Y'CbCr? We loose image quality when reading JCS_YCbCr as JCS_RGB
             read_rows<rgb8_pixel_t>( view );
             break;
         case JCS_CMYK:
-            io_error_if(_info._num_components!=4,"reader<jpeg>: error in image data");
+            io_error_if(this->_info._num_components!=4,"reader<jpeg>: error in image data");
             read_rows<cmyk8_pixel_t>( view );
             break;
         case JCS_YCCK:
-            io_error_if(_info._num_components!=4,"reader<jpeg>: error in image data");
+            io_error_if(this->_info._num_components!=4,"reader<jpeg>: error in image data");
             //!\todo add Y'CbCrK? We loose image quality when reading JCS_YCCK as JCS_CMYK
             this->_cinfo.out_color_space = JCS_CMYK;
             read_rows<cmyk8_pixel_t>( view );
@@ -225,7 +226,7 @@
             // unknown
         }
 
-        finish_decompress();
+        this->finish_decompress();
     }
 
     template< typename ImagePixel
@@ -240,14 +241,14 @@
                 );
 
       
-      std::vector<ImagePixel> buffer( _info._width );
+      std::vector<ImagePixel> buffer( this->_info._width );
 
       JSAMPLE *row_adr = reinterpret_cast< JSAMPLE* >( &buffer[0] );
 
       //Skip scanlines if necessary.
-      for( int y = 0; y <  _top_left.y; ++y )
+      for( int y = 0; y <  this->_top_left.y; ++y )
       {
-         io_error_if( jpeg_read_scanlines( &_cinfo
+         io_error_if( jpeg_read_scanlines( &this->_cinfo
                                          , &row_adr
                                          , 1
                                          ) !=1
@@ -257,22 +258,22 @@
       // Read data.
       for( int y = 0; y < view.height(); ++y )
       {
-         io_error_if( jpeg_read_scanlines( &_cinfo
+         io_error_if( jpeg_read_scanlines( &this->_cinfo
                                          , &row_adr
                                          , 1
                                          ) !=1
                     , "jpeg_read_scanlines: fail to read JPEG file" );
 
-         _cc_policy.read( buffer.begin() + _top_left.x
-                        , buffer.begin() + _dim.x
-                        , view.row_begin( y )
-                        );
+         this->_cc_policy.read( buffer.begin() + this->_top_left.x
+		                      , buffer.begin() + this->_dim.x
+		                      , view.row_begin( y )
+		                      );
       }
 
       //@todo: Finish up. There might be a better way to do that.
-      while( _cinfo.output_scanline <  _cinfo.image_height )
+      while( this->_cinfo.output_scanline <  this->_cinfo.image_height )
       {
-         io_error_if( jpeg_read_scanlines( &_cinfo
+         io_error_if( jpeg_read_scanlines( &this->_cinfo
                                          , &row_adr
                                          , 1
                                          ) !=1
@@ -286,4 +287,5 @@
 } // gil
 } // boost
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_IO_READ_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_IO_READ_HPP_INCLUDED
+
Index: detail/jpeg_io_write.hpp
===================================================================
--- detail/jpeg_io_write.hpp	(revision 317)
+++ detail/jpeg_io_write.hpp	(working copy)
@@ -167,4 +167,4 @@
 } // gil
 } // boost
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_IO_WRITE_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_IO_WRITE_HPP_INCLUDED
Index: detail/path_spec.hpp
===================================================================
--- detail/path_spec.hpp	(revision 317)
+++ detail/path_spec.hpp	(working copy)
@@ -75,4 +75,4 @@
 
 }}}
 
-#endif BOOST_GIL_EXTENSION_IO_DETAIL_PATH_SPEC_HPP_INCLUDED
+#endif //BOOST_GIL_EXTENSION_IO_DETAIL_PATH_SPEC_HPP_INCLUDED
Index: detail/read_and_convert_image.hpp
===================================================================
--- detail/read_and_convert_image.hpp	(revision 317)
+++ detail/read_and_convert_image.hpp	(working copy)
@@ -122,7 +122,7 @@
                            )
 {
     detail::file_stream_device< FormatTag > device( detail::convert_to_string( file_name )
-                                                  , detail::file_stream_device< FormatTag >::read_tag()
+                                                  , typename detail::file_stream_device< FormatTag >::read_tag()
                                                   );
 
     read_and_convert_image( device
@@ -298,4 +298,4 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_READ_AND_CONVERT_IMAGE_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_READ_AND_CONVERT_IMAGE_HPP_INCLUDED
Index: detail/read_and_convert_view.hpp
===================================================================
--- detail/read_and_convert_view.hpp	(revision 317)
+++ detail/read_and_convert_view.hpp	(working copy)
@@ -286,4 +286,4 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_READ_AND_CONVERT_VIEW_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_READ_AND_CONVERT_VIEW_HPP_INCLUDED
Index: detail/read_image.hpp
===================================================================
--- detail/read_image.hpp	(revision 317)
+++ detail/read_image.hpp	(working copy)
@@ -26,6 +26,7 @@
 #include "base.hpp"
 #include "io_device.hpp"
 #include "path_spec.hpp"
+#include "conversion_policies.hpp"
 
 namespace boost{ namespace gil {
 
@@ -86,7 +87,7 @@
                                                          >::type* ptr = 0
                       )
 {
-    typedef typename detail::is_adaptable_input_device<Device>::device_type device_type;
+    typedef typename detail::is_adaptable_input_device<FormatTag, Device>::device_type device_type;
     device_type dev(file);
     detail::reader<device_type,FormatTag,detail::read_and_no_convert> reader(dev);
 
@@ -119,7 +120,7 @@
                )
 {
     detail::file_stream_device<FormatTag> device( detail::convert_to_string( file_name )
-                                                , detail::file_stream_device<FormatTag>::read_tag()
+                                                , typename detail::file_stream_device<FormatTag>::read_tag()
                                                 );
 
     read_image( device
@@ -220,4 +221,4 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_READ_IMAGE_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_READ_IMAGE_HPP_INCLUDED
Index: detail/read_image_info.hpp
===================================================================
--- detail/read_image_info.hpp	(revision 317)
+++ detail/read_image_info.hpp	(working copy)
@@ -96,7 +96,7 @@
                )
 {
     detail::file_stream_device< FormatTag > reader( detail::convert_to_string( file_name )
-                                                  , detail::file_stream_device< FormatTag >::read_tag()
+                                                  , typename detail::file_stream_device< FormatTag >::read_tag()
                                                   );
 
     return read_image_info( reader
@@ -106,4 +106,4 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_IMAGE_READ_INFO_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_IMAGE_READ_INFO_HPP_INCLUDED
Index: detail/read_view.hpp
===================================================================
--- detail/read_view.hpp	(revision 317)
+++ detail/read_view.hpp	(working copy)
@@ -186,4 +186,5 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_READ_VIEW_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_READ_VIEW_HPP_INCLUDED
+
Index: detail/write_view.hpp
===================================================================
--- detail/write_view.hpp	(revision 317)
+++ detail/write_view.hpp	(working copy)
@@ -193,4 +193,4 @@
 } // namespace gil
 } // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_WRITE_VIEW_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_WRITE_VIEW_HPP_INCLUDED
Index: jpeg.hpp
===================================================================
--- jpeg.hpp	(revision 317)
+++ jpeg.hpp	(working copy)
@@ -19,4 +19,5 @@
 ///
 ////////////////////////////////////////////////////////////////////////////////////////
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_HPP_INCLUDED
+
Index: jpeg_all.hpp
===================================================================
--- jpeg_all.hpp	(revision 317)
+++ jpeg_all.hpp	(working copy)
@@ -22,4 +22,4 @@
 #include "jpeg_read.hpp"
 #include "jpeg_write.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_ALL_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_ALL_HPP_INCLUDED
Index: jpeg_read.hpp
===================================================================
--- jpeg_read.hpp	(revision 317)
+++ jpeg_read.hpp	(working copy)
@@ -29,4 +29,5 @@
 #include "detail/read_and_convert_image.hpp"
 #include "detail/read_and_convert_view.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_READ_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_READ_HPP_INCLUDED
+
Index: jpeg_write.hpp
===================================================================
--- jpeg_write.hpp	(revision 317)
+++ jpeg_write.hpp	(working copy)
@@ -25,4 +25,4 @@
 
 #include "detail/write_view.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_JPEG_WRITE_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_JPEG_WRITE_HPP_INCLUDED
Index: png_all.hpp
===================================================================
--- png_all.hpp	(revision 317)
+++ png_all.hpp	(working copy)
@@ -22,4 +22,4 @@
 #include "png_read.hpp"
 #include "png_write.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_PNG_ALL_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_PNG_ALL_HPP_INCLUDED
Index: png_io_old.hpp
===================================================================
--- png_io_old.hpp	(revision 317)
+++ png_io_old.hpp	(working copy)
@@ -174,4 +174,4 @@
 }  // namespace gil
 }  // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_PNG_IO_OLD_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_PNG_IO_OLD_HPP_INCLUDED
Index: png_read.hpp
===================================================================
--- png_read.hpp	(revision 317)
+++ png_read.hpp	(working copy)
@@ -30,4 +30,5 @@
 #include "detail/read_and_convert_view.hpp"
 
 
-#endif // BOOST_GIL_EXTENSION_IO_PNG_READ_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_PNG_READ_HPP_INCLUDED
+
Index: png_write.hpp
===================================================================
--- png_write.hpp	(revision 317)
+++ png_write.hpp	(working copy)
@@ -25,4 +25,4 @@
 
 #include "detail/write_view.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_PNG_WRITE_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_PNG_WRITE_HPP_INCLUDED
Index: tiff_all.hpp
===================================================================
--- tiff_all.hpp	(revision 317)
+++ tiff_all.hpp	(working copy)
@@ -22,4 +22,5 @@
 #include "tiff_read.hpp"
 #include "tiff_write.hpp"
 
-#endif // BOOST_GIL_EXTENSION_IO_TIFF_ALL_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_TIFF_ALL_HPP_INCLUDED
+
Index: tiff_io_old.hpp
===================================================================
--- tiff_io_old.hpp	(revision 317)
+++ tiff_io_old.hpp	(working copy)
@@ -175,4 +175,4 @@
 }  // namespace gil
 }  // namespace boost
 
-#endif // BOOST_GIL_EXTENSION_IO_TIFF_IO_OLD_HPP_INCLUDED
\ No newline at end of file
+#endif // BOOST_GIL_EXTENSION_IO_TIFF_IO_OLD_HPP_INCLUDED
Index: tiff_tags.hpp
===================================================================
--- tiff_tags.hpp	(revision 317)
+++ tiff_tags.hpp	(working copy)
@@ -273,3 +273,4 @@
 } // namespace boost
 
 #endif // BOOST_GIL_EXTENSION_IO_TIFF_TAGS_HPP
+
